<?php
class widgetCommentsComments extends cmsWidget {

    public $is_cacheable = false;

    public function run(){

        $controller_options = cmsController::loadOptions('comments');

        if(!empty($controller_options['disable_icms_comments'])){
            return false;
        }

        $type = $this->getOption('list_type', 'latests');
		$show_avatars = $this->getOption('show_avatars', true);
        $show_text    = $this->getOption('show_text', true); 
		$show_subject    = $this->getOption('show_subject', false);
        $text_str        = $this->getOption('text_str', 50); 
		$limit        = $this->getOption('limit', 10);
		$ctype_limit        = $this->getOption('ctype_limit', 20);
		$show_all_for_subject        = $this->getOption('show_all_for_subject');
		$target_category_parent        = $this->getOption('target_category_parent', false);

        $model_comments = cmsCore::getModel('comments');
		$core = cmsCore::getInstance();
		$ctype_name = $core->request->get('ctype_name');
		if(!$ctype_name){ return false; }
	

        $model_comments->orderBy('date_pub', 'desc');

        if (!cmsUser::isAllowed('comments', 'view_all')) {
            $model_comments->filterEqual('is_private', 0);
        }
		
		if($type=="target_id"){
			$current_ctype_item = cmsModel::getCachedResult('current_ctype_item');
			if(!$current_ctype_item){ return false; }			
			$model_comments->filterEqual('target_id', $current_ctype_item['id']);
		}
		if($type=="target_subject" || $type=="target_id" || $type=="target_category"){		
			$model_comments->filterEqual('target_subject', $ctype_name);
		}
		
		
		
        cmsEventsManager::hook('comments_list_filter', $model_comments);
        
		if($type=="target_category"){
        $items = $model_comments->filterIsNull('is_deleted')->getComments();
		}else{
		$items = $model_comments->filterIsNull('is_deleted')->limit($limit)->getComments();	
		}
        if (!$items) { return false; }

        $items = cmsEventsManager::hook('comments_before_list', $items);
		

		
		//////////////////////////// 
		//// Фильтр по категории ///
		////////////////////////////
		
				
		$cat_slug = false;
		if(strpos($core->uri, '.html') === false){
			$cat_slug = str_replace($ctype_name.'/', '', $core->uri);
		}
		
		$filtered_ids = false;		
		$targets_ids = array();
		if($type=="target_category"){
			
			
			if($cat_slug){
        
		    $content = cmsCore::getController('content');	
		    $model = $content->model;
			
			foreach($items as $item){
				$targets_ids[] = $item['target_id'];
			}
			if(!empty($targets_ids)){
			$filtered_ids = $this->getFilteredTargetsIds($ctype_name, $cat_slug, $targets_ids);				
			}
		
			}
			
			
        	
		}		
		if($filtered_ids){
			$filtered_items = array();
			foreach($items as $item){
				if(in_array($item['target_id'],$filtered_ids)){
				$filtered_items[] = $item;
				}
			}
		}
		
		
	
		
		if($type=="target_category" && !$show_all_for_subject && empty($filtered_items)){
			return false;
		}

        return array(
            'type' => $type,  
			'text_str' => $text_str, 
			'show_avatars' => $show_avatars,
            'show_text'    => $show_text,
			'show_subject'    => $show_subject,
            'items'        => ($filtered_ids && !empty($filtered_items) ? array_slice($filtered_items, 0, $limit) : $items)
        );

    }
	
	
	
	public function getFilteredTargetsIds($ctype_name, $cat_slug, $targets_ids){
		
		$model = cmsCore::getModel('content');	
		$category = $model->getCategoryBySLUG($ctype_name, $cat_slug);		

        $model->filterNotNull('comments');
		if(!empty($target_category_parent) && !empty($category['parent_id'])){
		$model->filterEqual('category_id', $category['parent_id']);	
		}else{
		$model->filterEqual('category_id', $category['id']);		
		}		
        $model->filterIn('id', $targets_ids);
		$model->selectOnly('id');

        return $model->limit(1000)->get("con_{$ctype_name}", function($item){			
            return $item['id'];
        });

    }

}
